import java.awt.*;
import java.awt.event.*;
import java.lang.Math;
public class SimEqDef extends Frame
{  public double LeftP, TopP, sX, sY;
   public double currentX, currentY; // ݂̕`ʒu
   public SimEqDef()
   {  setSize(600,600);
      addWindowListener(new WindowAdapter()
      { public void windowClosing(WindowEvent e){System.exit(0);}
      });
   }
   private double g(int ID, double X, double[] Y)// ς炱ύX
   {  if(ID==0) return X + Y[1];  //    DY0/DX = X + Y1
      else      return X       ;  //    DY1/DX = X   
   }
   private double f0(double X)
   {  double X2=X*X; double X3=X2*X;
      return ( X3/6 + X2/2);
   }
   private double f1(double X)
   {  return  X * X / 2;
   }
   private double[][] SimRunge(double[]Y0,double XST,double DX,int N,int M)
   { double [] K1  = new double [M];
     double [] K2  = new double [M];
     double [] K3  = new double [M];
     double [] K4  = new double [M];
     double [] YY  = new double [M];
     double [][] Y = new double [N][M];
     int i,k;
     for(k = 0; k< M; k++) Y[0][k] = Y0[k];
     double  X = XST;
     for(i = 1; i< N; i++)
     {  for(k = 0; k< M; k++) YY[k] = Y[i - 1][k];
        for(k = 0; k< M; k++) K1[k] = g(k, X, YY);
        for(k = 0; k< M; k++) YY[k] = Y[i - 1][k] + DX * K1[k] / 2;
        for(k = 0; k< M; k++) K2[k] = g(k, X + DX / 2, YY);
        for(k = 0; k< M; k++) YY[k] = Y[i - 1][k] + DX * K2[k] / 2;
        for(k = 0; k< M; k++) K3[k] = g(k, X + DX / 2, YY);
        for(k = 0; k< M; k++) YY[k] = Y[i - 1][k] + DX * K3[k];
        for(k = 0; k< M; k++) K4[k] = g(k, X + DX, YY);
        for(k = 0; k< M; k++)
          Y[i][k] = Y[i - 1][k] + (K1[k] + 2 * K2[k] + 2 * K3[k] + K4[k]) * DX / 6;
        X += DX;
     }
     return Y;
   }
   public void drawInit(double X1, double Y1, double SX, double SY)
   {  LeftP = X1; TopP = Y1; sX = SX; sY = SY;
   }
   public int Xpos(double X)
   {  return (int)(LeftP + X * sX);}
   public int Ypos(double Y)
   {  return (int)(TopP  + Y * sY);}
   public void drawLine(Graphics g, double X1, double Y1, double X2, double Y2)
   {  g.drawLine(Xpos(X1),Ypos(Y1),Xpos(X2),Ypos(Y2));
   }
   public void drawPoint(Graphics g, double X, double Y)
   {  g.fillOval(Xpos(X)-2,Ypos(Y)-2,4,4);
   }
   public void drawCircle(Graphics g, double X, double Y)
   {  g.drawOval(Xpos(X)-2,Ypos(Y)-2,4,4);
   }
   public void drawRect(Graphics g, double X, double Y)
   {  g.drawRect(Xpos(X)-2,Ypos(Y)-2,4,4);
   }
   public boolean Draw(Graphics g, double X, double Y, boolean Flag)
   {  if(Flag) drawLine(g, currentX, currentY, X, Y);
      currentX = X; currentY = Y;
      return true;
   }
   private double round(double D,int N)
   {  double DN=10*Math.pow(10.0,(double)(N-1));
      return Math.rint(D*DN)/DN;
   }
 
   public void paint(Graphics g)
   {   g.setColor(new Color(  128, 128, 128));
      drawInit( 50, 500, 200,  -80);
 
      setTitle("Aꎟ");
      boolean Flag = false; double X, Y;
      for(X = 0; X <  2; X +=0.1) drawLine(g, X, 0, X,  4);
      for(Y = 0; Y <= 4; Y +=0.2) drawLine(g, 0, Y, 2,  Y);
      for(int i = 0; i <= 2; i++) g.drawString("" + i, Xpos((double)i-0.01), Ypos(-0.3));
      for(Y = 0; Y <= 4.1; Y += 0.2)g.drawString("" + round(Y,1), Xpos(-0.12), Ypos(Y-0.06));
      g.setColor(new Color(  0, 0, 0));
      drawLine(g, 0, 0, 0, 1); drawLine(g, 2,  0, 2, 4);
      drawLine(g, 0, 0, 2, 0); drawLine(g, 0, 4, 2, 4);
      g.drawString("FFY0CԐFFY1CFF^l",100,100);
      g.drawString("   dY0/dX = X + Y1",100,140);
      g.drawString("   dY1/dX = X   ",100,160);
     
      double Y0=1; double XST=0; double DX=0.1; int N=21; int i;
      double [][]Z; int M=2;  // ̌ςƂM̒lς
      Flag=false;
      for(X = XST, i = 0; i < N; i++, X += DX)
      {  Flag= Draw(g, X, f0(X), Flag); drawPoint(g, X,f0(X));
      }
      Flag=false;
      for(X = XST, i = 0; i < N; i++, X += DX)
      {  Flag= Draw(g, X, f1(X), Flag); drawPoint(g, X,f1(X));
      }
      double []Z0={ 0, 0}; 
      Z = SimRunge(Z0, XST, DX, N, M);
      g.setColor(new Color(  0,  0, 255)); Flag = false;
      for(X = XST, i = 0; i < N; i++, X += DX) Flag= Draw(g, X, Z[i][0], Flag); 
      g.setColor(new Color(255,  0,   0)); Flag = false;
      for(X = XST, i = 0; i < N; i++, X += DX) Flag= Draw(g, X, Z[i][1], Flag); 
   } 
   public static void main(String[] args)
   {  Frame w = new SimEqDef();
      w.setVisible(true);
   }
}
